<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.3.361">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">

<meta name="author" content="Štěpán Zapadlo">
<meta name="dcterms.date" content="2023-11-15">

<title>IA168 AGT – Homework #1</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
</style>


<script src="hw1_files/libs/clipboard/clipboard.min.js"></script>
<script src="hw1_files/libs/quarto-html/quarto.js"></script>
<script src="hw1_files/libs/quarto-html/popper.min.js"></script>
<script src="hw1_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="hw1_files/libs/quarto-html/anchor.min.js"></script>
<link href="hw1_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="hw1_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" class="quarto-color-scheme" id="quarto-text-highlighting-styles">
<link href="hw1_files/libs/quarto-html/quarto-syntax-highlighting-dark.css" rel="prefetch" class="quarto-color-scheme quarto-color-alternate" id="quarto-text-highlighting-styles">
<script src="hw1_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="hw1_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="hw1_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" class="quarto-color-scheme" id="quarto-bootstrap" data-mode="light">
<link href="hw1_files/libs/bootstrap/bootstrap-dark.min.css" rel="prefetch" class="quarto-color-scheme quarto-color-alternate" id="quarto-bootstrap" data-mode="dark">

  <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

</head>

<body>

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">
<div id="quarto-margin-sidebar" class="sidebar margin-sidebar">
<div class="quarto-alternate-formats"><h2>Other Formats</h2><ul><li><a href="hw1.pdf"><i class="bi bi-file-pdf"></i>PDF</a></li></ul></div></div>
<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title">IA168 AGT – Homework #1</h1>
</div>



<div class="quarto-title-meta">

    <div>
    <div class="quarto-title-meta-heading">Author</div>
    <div class="quarto-title-meta-contents">
             <p>Štěpán Zapadlo </p>
          </div>
  </div>
    
    <div>
    <div class="quarto-title-meta-heading">Published</div>
    <div class="quarto-title-meta-contents">
      <p class="date">November 15, 2023</p>
    </div>
  </div>
  
    
  </div>
  

</header>

<div class="hidden">
$$ % Declare mathematics (so they can be overwritten for PDF)
% Font styles
% Sets
% Basic notation - vectors and random variables
%standard vector
%differentiated vector
%still a vector if vi doesn’t work
%differ. vector
%matrix
%differ. matrix
%#TODO
<p>%#TODO</p>
% Basic notation - general
% Special symbols
% Basic functions
%image %cardinality
% Operators - Analysis
% Linear algebra
% Linear algebra - Matrices
% Statistics
% Game Theory
% Optimization
% Useful commands
<p>$$</p>
</div>
<div id="exr-first" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 1 </strong></span>Consider a game where Player 1 selects a positive even integer less than 7 and, at the same time, Player 2 selects a positive odd integer less than 7. The payoff of the player with the higher selected number is the absolute difference of the selected numbers and the payoff of the other player is the sum of the selected numbers. Give a formal description of this game as a two-player strategic-form game (i.e., according to the definition from the lectures).</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>Surely <span class="math inline">\(N = \left\{1, 2\right\}\)</span>. From the description of the game we also obtain <span class="math inline">\(S_1 = \left\{2, 4, 6\right\}\)</span> and <span class="math inline">\(S_2 = \left\{1,3,5\right\}\)</span>. Lastly, the payoffs are given by <span class="math display">\[
\begin{aligned}
    u_1(s_1, s_2) &amp;= \begin{cases}
        \left| s_1 - s_2 \right|, &amp; s_1 &gt; s_2 \\
        s_1 + s_2, &amp; s_1 &lt; s_2
    \end{cases}, \\
    &amp; \&amp; \\
    u_2(s_1, s_2) &amp;= \begin{cases}
        \left| s_1 - s_2 \right|, &amp; s_2 &gt; s_1 \\
        s_1 + s_2, &amp; s_2 &lt; s_1
    \end{cases},
\end{aligned}
\]</span> from which we get the game in the strategic form <span class="math inline">\(G = (N, (S_i)_{i \in N}, (u_i)_{i \in N})\)</span>.</p>
</div>
<div id="exr-second" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 2 </strong></span>Consider a <strong>zero-sum</strong> game, where each player has exactly four strategies, called <span class="math inline">\(A_1, B_1, C_1, D_1\)</span>, and <span class="math inline">\(A_2, B_2, C_2, D_2\)</span>, respectively. Define the utility function of this game so that for both <span class="math inline">\(i \in \left\{1, 2\right\}\)</span>, all of the following conditions are satisfied:</p>
<ul>
<li>the strategy <span class="math inline">\(A_i\)</span> of player <span class="math inline">\(i\)</span> is strictly dominated;</li>
<li>the strategy <span class="math inline">\(B_i\)</span> of player <span class="math inline">\(i\)</span> is never-best-response, but not strictly dominated;</li>
<li>the strategy <span class="math inline">\(C_i\)</span> of player <span class="math inline">\(i\)</span> is not never-best-response;</li>
<li><span class="math inline">\((D_1, D_2)\)</span> is the only Nash equilibrium of the game.</li>
</ul>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>Let <span class="math inline">\(U\)</span> be the payoff matrix for this game – as it is a zero-sum game, then given the payoff matrix <span class="math inline">\(U = (u_{i,j})_{i,j \in \left\{1,\dots,4\right\}}\)</span> of player 1 we also know the payoff matrix <span class="math inline">\(V\)</span> of player 2 follows <span class="math inline">\(V = -U\)</span>.</p>
<p>Notice that the first condition is satisfied when <em>there must exist indices <span class="math inline">\(j,k \in \left\{2,3,4\right\}\)</span> such that for all indices <span class="math inline">\(i \in \left\{1,2,3,4\right\}\)</span> <span class="math inline">\(u_{1, i} &lt; u_{j, i}\)</span> and <span class="math inline">\(u_{i, 1} &gt; u_{i, k}\)</span></em>. Here the first part corresponds to strict domination of <span class="math inline">\(A_1\)</span> by <span class="math inline">\(j\)</span>-th strategy for player 1, and analogously the second part to strict domination of <span class="math inline">\(A_2\)</span> by <span class="math inline">\(k\)</span>-th strategy for player 2.</p>
<p>We shall now focus on the second condition, that is <span class="math inline">\(B_i\)</span> must be a never-best-response and not strictly dominated by any other strategy for both players <span class="math inline">\(i \in \left\{1,2\right\}\)</span>. This surely holds true, when <em>for all indices <span class="math inline">\(i \in \left\{1,2,3,4\right\}\)</span> there must exist indices <span class="math inline">\(j,k \in \left\{1,3,4\right\}\)</span> such that <span class="math inline">\(u_{2,i} &lt; u_{j,i}\)</span> and <span class="math inline">\(u_{i,2} &gt; u_{i,k}\)</span>. At the same time for all indices <span class="math inline">\(i' \in \left\{1,2,3,4\right\}\)</span> there exist indices <span class="math inline">\(j', k' \in \left\{1,3,4\right\}\)</span> and <span class="math inline">\(l,l' \in \left\{1,2,3,4\right\} \setminus \left\{i'\right\}\)</span> such that <span class="math inline">\(u_{2,i'} &lt; u_{j', i'}\)</span> while also <span class="math inline">\(u_{2,l} \geq u_{j', l}\)</span> and simarly <span class="math inline">\(u_{i', 2} &gt; u_{i', k'}\)</span> while also <span class="math inline">\(u_{l', 2} \leq u_{l', k'}\)</span></em>.</p>
<p>The third condition is similarly satisfied by: <em>there must exist indices <span class="math inline">\(i,j \in \left\{1,2,3,4\right\}\)</span> such that for all <span class="math inline">\(k \in \left\{1,2,4\right\}\)</span> holds <span class="math inline">\(u_{3,i} \geq u_{k,i}\)</span> and also <span class="math inline">\(u_{j, 3} \leq u_{j, k}\)</span></em>.</p>
<p>Finally the last condition is true when <em>for all <span class="math inline">\(i \in \left\{1, 2, 3\right\}\)</span> it holds that <span class="math inline">\(u_{4,4} \geq u_{i,4}\)</span> and <span class="math inline">\(u_{4,4} \leq u_{4,i}\)</span> and for all <span class="math inline">\(j,k \in \left\{1, 2, 3, 4\right\}\)</span> with <span class="math inline">\(j \neq k\)</span> there exist index <span class="math inline">\(l \in \left\{1,2,3,4\right\}\)</span> such that the profile <span class="math inline">\((j,k)\)</span> follows <span class="math inline">\(u_{j,k} &lt; u_{l,k}\)</span> and/or <span class="math inline">\(u_{j,k} &gt; u_{j,l}\)</span></em>.</p>
<p>Now consider a particular choice of <span class="math inline">\(U\)</span> as <span class="math display">\[
U = \begin{pmatrix}
    -1          &amp; -1            &amp; -2            &amp; -\frac 3 2    \\
    1           &amp; 0             &amp; -\frac 5 2    &amp; 0             \\
    \frac 3 2   &amp; 1             &amp; 1             &amp; -\frac 1 2    \\
    1           &amp; \frac 3 2     &amp; \frac 1 2     &amp; \frac 1 2
\end{pmatrix}.
\]</span></p>
<p>It is now easy to check that this payoff matrix <span class="math inline">\(U\)</span> satisfies all conditions, as <span class="math inline">\(D_i\)</span> dominates <span class="math inline">\(A_i\)</span> for both players <span class="math inline">\(i \in \left\{1,2\right\}\)</span>. Furthermore, given a belief <span class="math inline">\(b \in \left\{A_i, B_i, C_i, D_i\right\}\)</span> it is always better to play <span class="math inline">\(D_i\)</span> or <span class="math inline">\(C_i\)</span> to a belief <span class="math inline">\(b\)</span> rather than <span class="math inline">\(B_i\)</span> for both players <span class="math inline">\(i \in \left\{1,2\right\}\)</span> but there is no strategy (neither <span class="math inline">\(C_i\)</span> nor <span class="math inline">\(D_i\)</span>) that would be better to play for all beliefs <span class="math inline">\(b\)</span>.</p>
<p>On the same note, it is easy to see that <span class="math inline">\(C_1\)</span> is a best response to a belief <span class="math inline">\(C_2\)</span> and similarly <span class="math inline">\(C_2\)</span> is a best response to a belief <span class="math inline">\(A_1\)</span>. Last but not least, <span class="math inline">\((D_1, D_2)\)</span> is sure a Nash equilibrium and it can be easily checked that it is the only one.</p>
</div>
<div id="exr-third" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 3 </strong></span>For each <span class="math inline">\(n \in \left\{0, 1, \dots, 6\right\}\)</span>, give an example of a game where Player 1 has exactly 2 strategies, Player 2 has exactly 3 strategies and there are exactly <span class="math inline">\(n\)</span> Nash equilibria.</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>From the instructions easily follows that <span class="math inline">\(N = \left\{1,2\right\}\)</span> with <span class="math inline">\(S_1 = {a,b}, S_2={1,2,3}\)</span> and all such games can be prescribed by a payoff matrix <span class="math inline">\(U\)</span> for both players <span class="math display">\[
U = \begin{pmatrix}
    (a_1, a_1') &amp; (a_2, a_2') &amp; (a_3, a_3') \\
    (b_1, b_1') &amp; (b_2, b_2') &amp; (b_3, b_3')
\end{pmatrix},
\]</span> where <span class="math inline">\(a_1\)</span> is the payoff of player 1 for a profile <span class="math inline">\((a,1)\)</span> and <span class="math inline">\(a_1'\)</span> is the payoff of player 2 for the same case. Thus for</p>
<ol type="1">
<li><span class="math inline">\(n = 0\)</span>, payoff matrix <span class="math display">\[
U = \begin{pmatrix}
     (0, 1) &amp; (0, 0) &amp; (1, 0) \\
     (1, 0) &amp; (0, 0) &amp; (0, 1)
\end{pmatrix}
\]</span> satisfies the required number of Nash equilibria, i.e.&nbsp;zero.</li>
<li><span class="math inline">\(n \geq 1\)</span>, then the payoff matrix may be given by <span class="math display">\[
U = \begin{pmatrix}
     (1,1) &amp; (1,\mathbb{I}_{n \geq 2}) &amp; (1,\mathbb{I}_{n \geq 3}) \\
     (\mathbb{I}_{n \geq 4},1) &amp; (\mathbb{I}_{n \geq 5},\mathbb{I}_{n \geq 2}) &amp; (\mathbb{I}_{n = 6},\mathbb{I}_{n \geq 3})
\end{pmatrix},
\]</span> where we define an <em>indicator</em> as <span class="math display">\[
\mathbb{I}_{\text{condition}} = \begin{cases}
     1, &amp; \text{condition}, \\
     0, &amp; \text{otherwise}.
\end{cases}
\]</span> Now it is easy to check that for each <span class="math inline">\(n \geq 1\)</span>, this configuration of the payoff matrix <span class="math inline">\(U\)</span> satisfies the desired number of Nash equilibria (notice that for <span class="math inline">\(n \geq 1\)</span> Nash equilibria are “added” row-wise to the payoff matrix <span class="math inline">\(U\)</span>).</li>
</ol>
</div>
<div id="exr-fourth" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 4 </strong></span>Consider a game with <strong>mixed</strong> strategies, where each player has exactly two pure strategies, called <span class="math inline">\(A_1\)</span>, <span class="math inline">\(B_1\)</span>, and <span class="math inline">\(A_2\)</span>, <span class="math inline">\(B_2\)</span>, respectively. The utility functions are defined by the following table:</p>
<table class="table">
<thead>
<tr class="header">
<th></th>
<th><span class="math inline">\(A_2\)</span></th>
<th><span class="math inline">\(B_2\)</span></th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td><span class="math inline">\(A_1\)</span></td>
<td><span class="math inline">\((a,4)\)</span></td>
<td><span class="math inline">\((-a,2)\)</span></td>
</tr>
<tr class="even">
<td><span class="math inline">\(B_1\)</span></td>
<td><span class="math inline">\((3,1)\)</span></td>
<td><span class="math inline">\((1,3)\)</span></td>
</tr>
</tbody>
</table>
<p>In dependence on the parameter <span class="math inline">\(a \in \mathbb{R}\)</span>, find all Nash equilibria of this game, and for each of them, decide whether it is Pareto-optimal. Justify your reasoning.</p>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>The utility functions <span class="math inline">\(u_1, u_2\)</span> can be rewritten as follows <span id="eq-mixed-utilities"><span class="math display">\[
\begin{aligned}
u_1(x,y) &amp;= axy + 3(1-x)y - ax(1-y) + 1(1-x)(1-y) \\
    &amp;= ax(2y-1) + (1-x)(2y + 1), \\
u_2(x,y) &amp;= 4xy + 1(1-x)y + 2x(1-y) + 3(1-x)(1-y) \\
    &amp;= y(3x + 1) + (1-y)(3 - x).
\end{aligned}
\tag{1}\]</span></span></p>
<p>Let <span class="math inline">\(\sigma^* = (\sigma_1^*, \sigma_2^*)\)</span> be some Nash equilibrium. Consider a case, when the <span class="math inline">\(\mathrm{supp}\,(\sigma_1^*) = \left\{A_1, B_1\right\}\)</span>, i.e.&nbsp;such Nash equilibrium is purely mixed, then:</p>
<p><span id="eq-mixed-1"><span class="math display">\[
\begin{aligned}
u_1(A_1, y) = u_1(B_1, y) \implies a(2y - 1) &amp;= 2y + 1 \\
    2y(a-1) &amp;= 1 + a \\
    y &amp;= \frac {1 + a} {2(a-1)}.
\end{aligned}
\tag{2}\]</span></span></p>
<p>Notice that for <span class="math inline">\(a = -1\)</span> and <span class="math inline">\(a = 3\)</span>, <span class="math inline">\(y\)</span> becomes <span class="math inline">\(0\)</span> and <span class="math inline">\(1\)</span> respectively, which violates the assumption that <span class="math inline">\(y\)</span> gives a pure mixed strategy equilibrium. Hence for <span class="math inline">\(a \in [-1, 3]\)</span>, there is no Nash equilibrium in purely mixed strategies, as <span class="math inline">\(y\)</span> would either be negative, bigger than 1, or for <span class="math inline">\(a = 1\)</span>, there is no solution for <span class="math inline">\(y\)</span> given our assumption on the <span class="math inline">\(\mathrm{supp}\,(\sigma_1^*)\)</span>.</p>
<p>Similarly, for the second player, we obtain</p>
<p><span id="eq-mixed-2"><span class="math display">\[
\begin{aligned}
u_2(x, A_2) = u_2(x, B_2) \implies 3x + 1 &amp;= 3 - x \\
    4x &amp;= 2 \implies x = \frac 1 2.
\end{aligned}
\tag{3}\]</span></span></p>
<p>If there exists a pure mixed strategy Nash equilibrium, then there is at most 1 and is of form <span class="math display">\[
    \sigma^*_m = \left( \frac 1 2, \frac {1 + a} {2(a-1)} \right).
\]</span></p>
<p>For <span class="math inline">\(a \geq -1\)</span>, <span class="math inline">\((B_1, B_2)\)</span> is also an equilibrium, just as <span class="math inline">\((A_1, A_2)\)</span> is also an equilibrium for <span class="math inline">\(a \geq 3\)</span>. Should only 1 player mix, it is easy to see it has to be player 1. Now should player 2 play <span class="math inline">\(A_2\)</span>, then mixing makes sense for player 1 only for <span class="math inline">\(a = 3\)</span>, when <span class="math inline">\(x \in [0,1]\)</span>. But at the same time, rational player 2 plays <span class="math inline">\(A_2\)</span> only when <span id="eq-only-partial-mix-3"><span class="math display">\[
\begin{aligned}
    u_2(x, 1) &amp;&gt; u_2(x, 0) \\
    3x+1 &amp;&gt; 3 - x \\
    x &amp;\geq \frac 1 2.
\end{aligned}
\tag{4}\]</span></span></p>
<p>Similarly, for player <span class="math inline">\(2\)</span> playing <span class="math inline">\(B_2\)</span>, the player 1 should mix only for <span class="math inline">\(a = -1\)</span> with <span class="math inline">\(x \in [0,1]\)</span>. Using the same idea as in (<a href="#eq-only-partial-mix-3">4</a>) we get that rational player 2 plays pure <span class="math inline">\(B_2\)</span> only when <span class="math display">\[
\begin{aligned}
    u_2(x, 0) &amp;&gt; u_2(x, 1) \\
    3-x &amp;&gt; 3x - 1 \\
    x &amp;\leq \frac 1 2.
\end{aligned}
\]</span></p>
<p>Putting this all together, for</p>
<ol type="1">
<li><span class="math inline">\(a &lt; -1\)</span>, there is only purely mixed Nash equilibrium <span class="math inline">\(\left( \frac 1 2, \frac {1 + a} {2(a-1)} \right)\)</span>,</li>
<li><span class="math inline">\(a = -1\)</span>, then all Equilibria are of form <span class="math inline">\((x, B_2)\)</span> for every <span class="math inline">\(x \in \left[0, \frac 1 2 \right]\)</span></li>
<li><span class="math inline">\(a \in (-1, 3)\)</span>, there is only one Nash equilibrium <span class="math inline">\((B_1, B_2)\)</span>,</li>
<li><span class="math inline">\(a = 3\)</span>, then there is a pure Nash equilibrium <span class="math inline">\((A_1, A_2)\)</span> and all other Equilibria are of form <span class="math inline">\((x, A_2)\)</span> for every <span class="math inline">\(x \in \left[\frac 1 2, 1 \right]\)</span>,</li>
<li><span class="math inline">\(a &gt; 3\)</span>, there are 3 Nash equilibria, <span class="math inline">\((A_1,A_2)\)</span> and <span class="math inline">\((B_1, B_2)\)</span> in pure strategies, and a purely mixed Nash equilibrium <span class="math inline">\(\left( \frac 1 2, \frac {1 + a} {2(a-1)} \right)\)</span>.</li>
</ol>
<p>Notice that a partially mixed equilibrium is Pareto-dominated by its corresponding pure Nash equilibrium. For the mixing player, it does not matter (by definition), but for the player playing a pure strategy two cases might happen</p>
<ol type="1">
<li>there are at least two equal payoffs for a given row/column upon which the other player mixes,</li>
<li>every payoff is different in a given row/column upon which the other player mixes.</li>
</ol>
<p>Clearly, the second condition applies for both cases of partially mixed Nash equilibria, so our initial statement about Pareto-domination of partially mixed Nash equilibria holds. To evaluate Pareto-domination of <span class="math inline">\(\sigma^*_m\)</span>, substitute (<a href="#eq-mixed-1">2</a>) into (<a href="#eq-mixed-utilities">1</a>) gives us <span id="eq-mixed-pareto"><span class="math display">\[
\begin{aligned}
    u_1(a) &amp;= a \frac 1 2 \left( 2  \frac {1 + a} {2(a-1)} - 1 \right) + \left( 1 - \frac 1 2 \right) \left( 2 \frac {1 + a} {2(a-1)} + 1 \right) \\
        &amp;= a \frac 1 2 \frac {1 + a - (a - 1)} {a - 1} + \frac 1 2 \frac {1 + a + (a - 1)} {a - 1} \\
        &amp;= \frac {a + a} {a - 1} = \frac {2a} {a - 1}, \\
    u_2(a) &amp;= \frac {1 + a} {2(a-1)} \left( 3 \frac 1 2 + 1 \right) + \left( 1 - \frac {1 + a} {2(a-1)} \right) \left( 3 - \frac 1 2 \right) \\
        &amp;= \frac 5 {4(a-1)} \left( (1 + a) + (2(a - 1) - (1 + a)) \right) \\
        &amp;= \frac 5 {4(a-1)} \left( 1 + a + 2a - 2 - 1 - a \right) = \frac 5 2.
\end{aligned}
\tag{5}\]</span></span></p>
<p>The concept of Pareto-domination can be thought of in terms of positions of strategies in <span class="math inline">\(u_1, u_2\)</span>-plane. Payoffs of all mixed strategies then lie in the convex hull given by <span class="math inline">\(u_1, u_2\)</span> values of pure strategies. Also, realize conditions of Pareto-optimality are satisfied only if for a given point <span class="math inline">\((u, v)\)</span> in the <span class="math inline">\(u_1, u_2\)</span>-plane, there is no <span class="math inline">\((u', v')\)</span> from the convex hull of payoffs of pure strategies that is above and/or to the right of <span class="math inline">\((u,v)\)</span>.</p>
<p>Furthermore, notice that points <span class="math inline">\(A = (u_1(A_1,A_2), u_2(A_1, A_2))\)</span> and <span class="math inline">\(B = (u_1(A_1,B_2), u_2(A_1, B_2))\)</span> only move in the <span class="math inline">\(u_1\)</span> axis with varying <span class="math inline">\(a\)</span>, and that points <span class="math inline">\(C\)</span>, and <span class="math inline">\(D\)</span> in the <span class="math inline">\(u_1, u_2\)</span>-plane corresponding to <span class="math inline">\((B_1, A_2)\)</span>, and <span class="math inline">\((B_1, B_2)\)</span>, respectively, are not dependent on <span class="math inline">\(a\)</span>. As we have discussed earlier, it is sufficient to study only pure or purely mixed existing Nash equilibria.</p>
<p>To show that for <span class="math inline">\(a &lt; -1\)</span> the mixed strategies Nash equilibrium with corresponding point <span class="math inline">\(M = (u_1(\sigma^*_m), u_2(\sigma_m^*))\)</span> in <span class="math inline">\(u_1, u_2\)</span>-plane is Pareto-dominated, it at first suffices to calculate the dot product of vector from <span class="math inline">\(DS\)</span> to <span class="math inline">\(M\)</span>, e.g.&nbsp;<span class="math inline">\(M - D\)</span>, with the normal vector <span class="math inline">\(\boldsymbol{n}_{CD}\)</span> of the line <span class="math inline">\(CD\)</span> (which is fixed for varying <span class="math inline">\(a\)</span>). The normal vector is <span class="math inline">\(\boldsymbol{n}_{CD} = (-1,-1)\)</span> and thus from (<a href="#eq-mixed-pareto">5</a>) we obtain <span id="eq-m-under-cd"><span class="math display">\[
\left\langle \boldsymbol{n}_{CD}, M - D \right\rangle = \left\langle (-1, -1), M - (1,3) \right\rangle = - \frac {2a} {a-1} + 1 - \frac 5 2 + 3 = \frac {2a} {1 - a} + \frac 3 2 &gt; 0
\tag{6}\]</span></span> for <span class="math inline">\(a \in (-3, -1)\)</span>. Then we can repeat this process for the normal vector <span class="math inline">\(\boldsymbol{n}_{BD}\)</span> of the line <span class="math inline">\(BD\)</span>, which has the form <span class="math display">\[
B - D = (-a - 1, 2 - 3) = (-a - 1, -1) \implies \boldsymbol{n}_{BD} = (-1, a + 1),
\]</span> hence <span id="eq-m-under-bd"><span class="math display">\[
\begin{aligned}
    \left\langle \boldsymbol{n}_{BD}, M - D \right\rangle &amp;= \left\langle (-1, a+1), M - (1,3) \right\rangle \\
        &amp;= - \frac {2a} {a-1} + 1 + (a+1) (\frac 5 2 - 3) \\
        &amp;= \frac {2a} {1 - a} + 1 - \frac a 2 - \frac 1 2 \\
        &amp;= \frac {2a - \frac 1 2 a(1 - a)} {1 - a} + \frac 1 2 \\
        &amp;= \frac {2a - \frac a 2  + \frac {a^2} 2} {1 - a} + \frac 1 2 \\
        &amp;= \frac {a^2 + 3a} {2(1 - a)} + \frac 1 2 &gt; 0
\end{aligned}
\tag{7}\]</span></span> for all <span class="math inline">\(a &lt; -3\)</span>. Combining (<a href="#eq-m-under-cd">6</a>) and (<a href="#eq-m-under-bd">7</a>) produces that <span class="math inline">\(M\)</span> stays “under” the edge (thus in a Pareto-suboptimal space) of the convex hull for all considered <span class="math inline">\(a &lt; -1\)</span>, see <a href="#fig-convex-hulls-1">Figure&nbsp;1 (a)</a>, which implies that <span class="math inline">\(\sigma_m^*\)</span> is not Pareto-optimal. Using similar arguments, again see <a href="#fig-convex-hulls">Figure&nbsp;1</a>, it can be proven that for</p>
<ul>
<li><span class="math inline">\(a &lt; -1\)</span> the strategy profile <span class="math inline">\((B_1, B_2)\)</span> is Pareto-optimal but is not a Nash equilibrium,</li>
<li><span class="math inline">\(a \in [-1, 0]\)</span> the strategy profile <span class="math inline">\((B_1, B_2)\)</span> is Pareto-optimal and <strong>is</strong> a pure Nash equilibrium. The mixed Nash equilibrium <span class="math inline">\(\sigma^*_m\)</span> exists in this case but from (<a href="#eq-mixed-pareto">5</a>) follows easily that is it Pareto-dominated by <span class="math inline">\((B_1, B_2)\)</span>,</li>
<li><span class="math inline">\(a \in (0, 3)\)</span> the strategy profile <span class="math inline">\((A_1, A_2)\)</span> is Pareto-optimal but is not a Nash equilibrium (in this case, whole line segment <span class="math inline">\(AC\)</span> is actually Pareto-optimal, as opposed to only point <span class="math inline">\(A\)</span>). For example a mixed strategy profile <span class="math inline">\(\left( \frac 2 3, 1 \right)\)</span>, which has payoff <span class="math inline">\(\left( \frac {2a} 3 + 1, 3 \right)\)</span>, Pareto-dominates <span class="math inline">\(D = (B_1, B_2)\)</span> for all considered <span class="math inline">\(a\)</span> of this case,</li>
<li><span class="math inline">\(a \geq 3\)</span> the strategy profile <span class="math inline">\((A_1, A_2)\)</span> is Pareto-optimal and <strong>is</strong> a pure Nash equilibrium. Again, it can be easily shown from (<a href="#eq-mixed-pareto">5</a>) that <span class="math inline">\((A_1, A_2)\)</span> Pareto-dominates both <span class="math inline">\((B_1, B_2)\)</span> and the mixed Nash equilibrium <span class="math inline">\(\sigma^*_m\)</span>.</li>
</ul>
<div id="fig-convex-hulls" class="cell quarto-layout-panel" data-execution_count="2">
<figure class="figure">
<div class="quarto-layout-row quarto-layout-valign-top">
<div class="cell-output cell-output-display quarto-layout-cell quarto-layout-cell-subref" style="flex-basis: 50.0%;justify-content: center;">
<div id="fig-convex-hulls-1" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="hw1_files/figure-html/fig-convex-hulls-output-1.svg" class="img-fluid figure-img" data-ref-parent="fig-convex-hulls"></p>
<figcaption class="figure-caption">(a) <span class="math inline">\(a = -1.5 \in (-\infty, -1)\)</span></figcaption>
</figure>
</div>
</div>
<div class="cell-output cell-output-display quarto-layout-cell quarto-layout-cell-subref" style="flex-basis: 50.0%;justify-content: center;">
<div id="fig-convex-hulls-2" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="hw1_files/figure-html/fig-convex-hulls-output-2.svg" class="img-fluid figure-img" data-ref-parent="fig-convex-hulls"></p>
<figcaption class="figure-caption">(b) <span class="math inline">\(a = -0.5 \in [-1, 0]\)</span></figcaption>
</figure>
</div>
</div>
</div>
<div class="quarto-layout-row quarto-layout-valign-top">
<div class="cell-output cell-output-display quarto-layout-cell quarto-layout-cell-subref" style="flex-basis: 50.0%;justify-content: center;">
<div id="fig-convex-hulls-3" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="hw1_files/figure-html/fig-convex-hulls-output-3.svg" class="img-fluid figure-img" data-ref-parent="fig-convex-hulls"></p>
<figcaption class="figure-caption">(c) <span class="math inline">\(a = 2 \in (0,3)\)</span> (<span class="math inline">\(\sigma_m^*\)</span> does not exist here)</figcaption>
</figure>
</div>
</div>
<div class="cell-output cell-output-display quarto-layout-cell quarto-layout-cell-subref" style="flex-basis: 50.0%;justify-content: center;">
<div id="fig-convex-hulls-4" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="hw1_files/figure-html/fig-convex-hulls-output-4.svg" class="img-fluid figure-img" data-ref-parent="fig-convex-hulls"></p>
<figcaption class="figure-caption">(d) <span class="math inline">\(a = 3.5 \in [3, \infty)\)</span></figcaption>
</figure>
</div>
</div>
</div>
<p></p><figcaption class="figure-caption">Figure&nbsp;1: Convex hulls in <span class="math inline">\(u_1, u_2\)</span>-plane</figcaption><p></p>
</figure>
</div>
</div>
<div id="exr-fifth" class="theorem exercise">
<p><span class="theorem-title"><strong>Exercise 5 </strong></span>Prove or disprove:</p>
<ol type="a">
<li>IESDS creates no new Nash equilibria in any game with finitely many strategies.</li>
<li>IESDS creates no new Nash equilibria in any game.</li>
</ol>
</div>
<div class="solution proof">
<p><span class="proof-title"><em>Solution</em>. </span>First, we shall focus on the part a. of <a href="#exr-fifth">Exercise&nbsp;5</a>. Consider a game <span class="math inline">\(G = G_{DS}^{0} = \left( N, (S_i)_{i \in N}, (u_i)_{i \in N} \right)\)</span>, where <span class="math inline">\(N = \left\{1, 2\right\}\)</span>, <span class="math inline">\(S_i = D_i^0\)</span> is a <strong>finite</strong> set of pure strategies of player <span class="math inline">\(i\)</span> for every <span class="math inline">\(i \in N\)</span>, and lastly <span class="math inline">\(u_i\)</span> are their utility functions. Moreover, denote by <span class="math inline">\(G_{DS}^{k}\)</span> a game corresponding to the <span class="math inline">\(k\)</span>-th iteration of IESDS. A game <span class="math inline">\(G_{DS}^{k+1}\)</span> is obtained from <span class="math inline">\(G_{DS}^{k}\)</span> by restricting strategies <span class="math inline">\(D_i^k\)</span> of player <span class="math inline">\(i\)</span> to <span class="math inline">\(D_i^{k+1}\)</span>, where <span class="math inline">\(D_i^{k+1}\)</span> is the set of all pure strategies of player <span class="math inline">\(i\)</span> that are not strictly dominated in <span class="math inline">\(G_{DS}^{k}\)</span>. As such, <span class="math inline">\(D_i^{k+1} \subseteq D_i^k\)</span> can be easily obtained for every player <span class="math inline">\(i \in N\)</span>.</p>
<p>Now consider a pure Nash equilibrium <span class="math inline">\(s^* = (s_1^*, s_2^*)\)</span> in the game <span class="math inline">\(G_{DS}^{k+1}\)</span>, where <span class="math inline">\(s_i^* \in D_i^{k+1}\)</span> for every player <span class="math inline">\(i \in N\)</span>. Surely, <span class="math inline">\(s^*\)</span> is a valid strategy profile in <span class="math inline">\(G_{DS}^{k}\)</span> and also <span class="math inline">\(s_i^* \in D_i^k\)</span> for both players. Assume <span class="math inline">\(s^*\)</span> is <strong>not</strong> a pure Nash equilbrium in <span class="math inline">\(G_{DS}^{k}\)</span>, i.e.&nbsp;there exists player <span class="math inline">\(j\)</span> and their strategy <span class="math inline">\(s_j\)</span> such that <span class="math inline">\(u_j(s_j, s^*_{-j}) &gt; u_j(s_j^*, s^*_{-j})\)</span>. For a finite <span class="math inline">\(D_j^k\)</span>, we can choose <span class="math inline">\(s_j \in D_j^k\)</span> (under our assumptions) such that <span class="math inline">\(s_j\)</span> is <strong>not</strong> dominated in <span class="math inline">\(G_{DS}^{k}\)</span>. Hence <span class="math inline">\(s_j\)</span> survives IESDS, i.e.&nbsp;<span class="math inline">\(s_j \in D_j^{k+1}\)</span>. But then <span class="math inline">\(s^*\)</span> is not a Nash equilibrium in <span class="math inline">\(G_{DS}^{k+1}\)</span>, which is a contradiction. Thus <span class="math inline">\(s^*\)</span> must be a pure Nash equilibrium in <span class="math inline">\(G_{DS}^{k}\)</span>.</p>
<p>Let us now focus on the second part. Assume that <span class="math inline">\(s^* = (s_1^*, s_2^*) \in D_1^{k+1} \times D_2^{k+1}\)</span> is a Nash equilibrium in <span class="math inline">\(G_{DS}^{k+1}\)</span>. From the proof above, we can deduce the following must happen in order for IESDS to create a new Nash equilibrium:</p>
<ol type="1">
<li>there must exist a strategy <span class="math inline">\(s_j \in D_j^k\)</span> for player <span class="math inline">\(j\)</span>, WLOG say <span class="math inline">\(j = 1\)</span>, such that <span id="eq-exists-better"><span class="math display">\[
u_1(s_1, s^*_2) &gt; u_1(s_1^*, s_2^*)
  \tag{8}\]</span></span> for <span class="math inline">\(s_1 \in D_1^k\)</span>.</li>
<li>every possible <span class="math inline">\(s_1\)</span> in the previous condition (<a href="#eq-exists-better">8</a>) must be dominated by some other <span class="math inline">\(s_1' \in D_1^k\)</span>
<ul>
<li>if there was <span class="math inline">\(s_1\)</span> not dominated, it would survive IESDS and hence <span class="math inline">\(s^*\)</span> would not be a Nash equilibrium</li>
</ul></li>
<li>the Nash equilibrium strategy <span class="math inline">\(s_1^*\)</span> must <strong>not</strong> be dominated, so that it survives IESDS</li>
</ol>
<p>From the definition of a strictly dominated strategy follows that <span class="math inline">\(s_1' \succ s_1\)</span> iff <span id="eq-alt-dominated"><span class="math display">\[
u_1(s_1', s_2) &gt; u_1(s_1, s_2)
\tag{9}\]</span></span> for every <span class="math inline">\(s_2 \in D_2^k\)</span>. Putting together (<a href="#eq-exists-better">8</a>) and (<a href="#eq-alt-dominated">9</a>) we obtain <span id="eq-domination-chain"><span class="math display">\[
u_1(s_1', s^*_2) &gt; u_1(s_1, s^*_2) &gt; u_1(s_1^*, s_2^*).
\tag{10}\]</span></span></p>
<p>The third condition leads to the necessity of the existence of some <span class="math inline">\(s_2' \in D_2^k\)</span> for every <span class="math inline">\(s_1 \in D_1^k\)</span> satisfying (<a href="#eq-exists-better">8</a>) such that <span id="eq-exists-worse"><span class="math display">\[
u_1(s_1, s_2') \leq u_1(s_1^*, s_2').
\tag{11}\]</span></span></p>
<p>From equations (<a href="#eq-domination-chain">10</a>) and (<a href="#eq-exists-better">8</a>) follows that <span class="math inline">\(u_1(\cdot, s_2^*)\)</span> for a fixed <span class="math inline">\(s_2^* \in D_2^k\)</span> must have a (global) minimum in <span class="math inline">\(s_1^*\)</span>. On the other hand, equation (<a href="#eq-exists-worse">11</a>) leads to <span class="math inline">\(u_1(\cdot, s_2')\)</span> for a (possibly different) fixed <span class="math inline">\(s_2' \in D_2^k\)</span> having a (global) maximum at <span class="math inline">\(s_1^*\)</span>.</p>
<p>Consider now <span class="math inline">\(D_1^k = D_2^k = \mathbb{R}^+_0\)</span> and utility functions, see <a href="#fig-utils">Figure&nbsp;2</a>, <span class="math display">\[
\begin{aligned}
    u_1(s_1, s_2) &amp;= \begin{cases}
        1, &amp; s_1 = 0 \land s_2 \neq 0, \\
        \frac 2 {\pi} \arctan(s_1), &amp; \text{otherwise}
    \end{cases} \\
    &amp;\&amp; \\
    u_2(s_1, s_2) &amp;=
    \begin{cases}
        1, &amp; s_1 \neq 0 \land s_2 = 0, \\
        \frac 2 {\pi} \arctan(s_2), &amp; \text{otherwise}
    \end{cases}.
\end{aligned}
\]</span></p>
<p>Notice for both players <span class="math inline">\(s_i\)</span> is dominated iff <span class="math inline">\(s_i &gt; 0\)</span>, since <span class="math inline">\(\arctan\)</span> is strictly increasing. At the same time, both players playing rationally should deviate from <span class="math inline">\(s^* = (0,0)\)</span>. Therefore after IESDS, <span class="math inline">\(G_{DS}^{k+1}\)</span> will have strategy sets <span class="math inline">\(D_1^{k+1} = D_2^{k+1} = \left\{0\right\}\)</span> and <span class="math inline">\((0,0)\)</span> must be a Nash equilibrium.</p>
</div>
<div id="fig-utils" class="cell quarto-layout-panel" data-execution_count="3">
<figure class="figure">
<div class="quarto-layout-row quarto-layout-valign-top">
<div class="cell-output cell-output-display quarto-layout-cell quarto-layout-cell-subref" style="flex-basis: 50.0%;justify-content: center;">
<div id="fig-utils-1" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="hw1_files/figure-html/fig-utils-output-1.svg" class="img-fluid figure-img" data-ref-parent="fig-utils"></p>
<figcaption class="figure-caption">(a) <span class="math inline">\(s_2 = 0\)</span></figcaption>
</figure>
</div>
</div>
<div class="cell-output cell-output-display quarto-layout-cell quarto-layout-cell-subref" style="flex-basis: 50.0%;justify-content: center;">
<div id="fig-utils-2" class="quarto-figure quarto-figure-center anchored">
<figure class="figure">
<p><img src="hw1_files/figure-html/fig-utils-output-2.svg" class="img-fluid figure-img" data-ref-parent="fig-utils"></p>
<figcaption class="figure-caption">(b) <span class="math inline">\(s_2 = 1\)</span></figcaption>
</figure>
</div>
</div>
</div>
<p></p><figcaption class="figure-caption">Figure&nbsp;2: Utility function <span class="math inline">\(u_1(s_1, s_2)\)</span> in <span class="math inline">\(s_1\)</span> for a fixed <span class="math inline">\(s_2\)</span></figcaption><p></p>
</figure>
</div>

</main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const disableStylesheet = (stylesheets) => {
    for (let i=0; i < stylesheets.length; i++) {
      const stylesheet = stylesheets[i];
      stylesheet.rel = 'prefetch';
    }
  }
  const enableStylesheet = (stylesheets) => {
    for (let i=0; i < stylesheets.length; i++) {
      const stylesheet = stylesheets[i];
      stylesheet.rel = 'stylesheet';
    }
  }
  const manageTransitions = (selector, allowTransitions) => {
    const els = window.document.querySelectorAll(selector);
    for (let i=0; i < els.length; i++) {
      const el = els[i];
      if (allowTransitions) {
        el.classList.remove('notransition');
      } else {
        el.classList.add('notransition');
      }
    }
  }
  const toggleColorMode = (alternate) => {
    // Switch the stylesheets
    const alternateStylesheets = window.document.querySelectorAll('link.quarto-color-scheme.quarto-color-alternate');
    manageTransitions('#quarto-margin-sidebar .nav-link', false);
    if (alternate) {
      enableStylesheet(alternateStylesheets);
      for (const sheetNode of alternateStylesheets) {
        if (sheetNode.id === "quarto-bootstrap") {
          toggleBodyColorMode(sheetNode);
        }
      }
    } else {
      disableStylesheet(alternateStylesheets);
      toggleBodyColorPrimary();
    }
    manageTransitions('#quarto-margin-sidebar .nav-link', true);
    // Switch the toggles
    const toggles = window.document.querySelectorAll('.quarto-color-scheme-toggle');
    for (let i=0; i < toggles.length; i++) {
      const toggle = toggles[i];
      if (toggle) {
        if (alternate) {
          toggle.classList.add("alternate");     
        } else {
          toggle.classList.remove("alternate");
        }
      }
    }
    // Hack to workaround the fact that safari doesn't
    // properly recolor the scrollbar when toggling (#1455)
    if (navigator.userAgent.indexOf('Safari') > 0 && navigator.userAgent.indexOf('Chrome') == -1) {
      manageTransitions("body", false);
      window.scrollTo(0, 1);
      setTimeout(() => {
        window.scrollTo(0, 0);
        manageTransitions("body", true);
      }, 40);  
    }
  }
  const isFileUrl = () => { 
    return window.location.protocol === 'file:';
  }
  const hasAlternateSentinel = () => {  
    let styleSentinel = getColorSchemeSentinel();
    if (styleSentinel !== null) {
      return styleSentinel === "alternate";
    } else {
      return false;
    }
  }
  const setStyleSentinel = (alternate) => {
    const value = alternate ? "alternate" : "default";
    if (!isFileUrl()) {
      window.localStorage.setItem("quarto-color-scheme", value);
    } else {
      localAlternateSentinel = value;
    }
  }
  const getColorSchemeSentinel = () => {
    if (!isFileUrl()) {
      const storageValue = window.localStorage.getItem("quarto-color-scheme");
      return storageValue != null ? storageValue : localAlternateSentinel;
    } else {
      return localAlternateSentinel;
    }
  }
  let localAlternateSentinel = 'default';
  // Dark / light mode switch
  window.quartoToggleColorScheme = () => {
    // Read the current dark / light value 
    let toAlternate = !hasAlternateSentinel();
    toggleColorMode(toAlternate);
    setStyleSentinel(toAlternate);
  };
  // Ensure there is a toggle, if there isn't float one in the top right
  if (window.document.querySelector('.quarto-color-scheme-toggle') === null) {
    const a = window.document.createElement('a');
    a.classList.add('top-right');
    a.classList.add('quarto-color-scheme-toggle');
    a.href = "";
    a.onclick = function() { try { window.quartoToggleColorScheme(); } catch {} return false; };
    const i = window.document.createElement("i");
    i.classList.add('bi');
    a.appendChild(i);
    window.document.body.appendChild(a);
  }
  // Switch to dark mode if need be
  if (hasAlternateSentinel()) {
    toggleColorMode(true);
  } else {
    toggleColorMode(false);
  }
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    text: function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn) {
    const config = {
      allowHTML: true,
      content: contentFn,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start'
    };
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->



</body></html>